SystemOrganization addCategory: #DijEvolution!

Object subclass: #DijEvolution
	instanceVariableNames: 'ancestors pool spawningBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijEvolution methodsFor: 'initialize-release' stamp: 'hjo 6/27/2012 04:05'!
initialize

	super initialize.
	pool := OrderedCollection new.
	ancestors := OrderedCollection new. "should be Set?"! !

!DijEvolution methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:13'!
pool: anOrderedCollection 

	pool := anOrderedCollection! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 09:51'!
spawningBlock: aBlockClosure 
	spawningBlock := aBlockClosure ! !

!DijEvolution methodsFor: 'stepping and presenter' stamp: 'hjo 6/27/2012 09:52'!
step

	| news uniqueNews |
	pool do: [:each| 
		news := spawningBlock value: each.
		uniqueNews := news copyWithoutAll: ancestors.  
		].
	ancestors addAll: pool.
	pool := uniqueNews asSet asArray.
! !

Object subclass: #DijLife
	instanceVariableNames: 'birthExpressions cost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:27'!
birthExpression: aBlockClosure 

	birthExpressions := Array with: aBlockClosure.! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
birthExpressions
	^ birthExpressions! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
birthExpressions: aCollection
	birthExpressions := aCollection
! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost
	^ cost! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost: aNumber
	cost := aNumber
! !
